/****************************************************/
/* bin2p31                                          */
/****************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	S_LEN	255
#define	BUFNUM	16000

int main(int argc, char **argv)
{
	char	infile[S_LEN],outfile[S_LEN];
	FILE	*infp, *outfp;
	int		c,num,i;
	int		size,fnum,secnum;
	int		flag1d;

	if (argc != 3 && argc != 4) {
		fprintf(stderr, "Usage: bin2p31 infile -minsize(Kbytes) [-1d]\n");
		exit(1);
	}

/* open files */
	strncpy(infile ,argv[1],200);
	strncat(infile ,".bin",5);
	strncpy(outfile,argv[1],200);
	strncat(outfile,".p31",5);

	if ((infp = fopen(infile, "rb")) == NULL) {
		strncpy(infile ,argv[1],200);
		strncat(infile ,".dsk",5);
		if ((infp = fopen(infile, "rb")) == NULL) {
			perror(infile);
			exit(1);
		}
	}

	if ((outfp = fopen(outfile, "wb")) == NULL) {
		perror(outfile);
		exit(1);
	}

	if (argv[2][0] != '-') {
		fprintf(stderr, "Usage: bin2p31 infile -minsize(Kbytes) [-1d]\n");
		exit(1);
	}

	size = atoi(&argv[2][1]) * 1024;

	flag1d = 0;
	if (argc == 4) {
		if ( strcmp(argv[3],"-1d") != 0 ) {
			fprintf(stderr, "Usage: bin2p31 infile -minsize(Kbytes) [-1d]\n");
			exit(1);
		}
		flag1d = 1;
	}

	num = 0;
	fnum = 0;
	secnum = 0;
	while ((c = fgetc(infp)) != EOF) {
		fputc(c,outfp);
		num ++;
		if (num == 256) {
			num = 0;
			for (i = 0;i < 256;i ++) {
				fputc(0,outfp);
			}

			if ( flag1d ) {
				secnum ++;
				if ( secnum  == 16 ) {
					secnum = 0;
					for (i = 0;i < 256*16*2;i ++) {
						fputc(0,outfp);
					}
				}
			}

		}

		fnum ++;
		if (fnum == size) {
			fnum = 0;
		}
	}

	if (fnum != 0) {
		for (;fnum < size;fnum ++) {
			fputc(0xff,outfp);
			num ++;
			if (num == 256) {
				num = 0;
				for (i = 0;i < 256;i ++) {
					fputc(0,outfp);
				}
			}

			if ( flag1d ) {
				secnum ++;
				if ( secnum  == 16 ) {
					secnum = 0;
					for (i = 0;i < 256*16*2;i ++) {
						fputc(0,outfp);
					}
				}
			}

		}
	}

	fclose(infp);
	fclose(outfp);

	return(0);
}
